package sdanderson.androidchartsdemos;

import android.graphics.Color;
import android.support.v4.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

import sdanderson.androidcharts.BarChart.BarChart;
import sdanderson.androidcharts.Common.Coordinate;
import sdanderson.androidcharts.LineChart.LineChart;
import sdanderson.androidcharts.PieChart.PieChart;

/**
 * A placeholder fragment containing a simple view.
 */
public class DemosMainActivityFragment extends Fragment {

    public DemosMainActivityFragment() {
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View v = inflater.inflate(R.layout.fragment_demos_main, container, false);

        final PieChart p1 = (PieChart) v.findViewById(R.id.demo_main_piechart1);
        p1.addSlice("Passed", 230, Color.RED);
        p1.addSlice("Failed", 100, Color.DKGRAY);
        p1.addSlice("Unknown", 20, Color.BLUE);
        p1.percentalize(true);
        p1.setDecimalFormatPopupValue(new DecimalFormat("#.###"));
        p1.setBorderWidth(6f);
        p1.setBorderColor(Color.WHITE);
        p1.setAnimationTime(500f);

        final PieChart p2 = (PieChart) v.findViewById(R.id.demo_main_piechart2);
        p2.addSlice("Red", 1293, Color.RED);
        p2.addSlice("Dark Gray", 4581, Color.DKGRAY);
        p2.addSlice("Blue", 4014, Color.BLUE);
        p2.addSlice("White", 2491, Color.WHITE);
        p2.addSlice("Light Gray", 5911, Color.LTGRAY);
        p2.addSlice("Green", 10111, Color.GREEN);
        p2.setDecimalFormatPopupValue(new DecimalFormat("#.##"));
        p2.setUseNumberAbbreviationSuffixValue(true);
        p2.setNumberSuffixes("kmbt");
        p2.setNumberGroupSplit(3);
        p2.setBorderWidth(6f);
        p2.setBorderColor(Color.YELLOW);
        p2.setAnimationTime(2000f);
        p2.setUseAnimation(true);

        final LineChart l1 = (LineChart) v.findViewById(R.id.demo_main_linechart1);
        List<Coordinate<Float, Float>> tempValues1 = new ArrayList<>();
        tempValues1.add(new Coordinate<>(2010f, 100433f));
        tempValues1.add(new Coordinate<>(2011f, -100413f));
        tempValues1.add(new Coordinate<>(2012f, -300451f));
        tempValues1.add(new Coordinate<>(2013f, 200341f));
        tempValues1.add(new Coordinate<>(2014f, -250436f));
        tempValues1.add(new Coordinate<>(2015f, 100642f));
        tempValues1.add(new Coordinate<>(2016f, 300522f));

        List<Coordinate<Float, Float>> tempValues2 = new ArrayList<>();
        tempValues2.add(new Coordinate<>(2012f, 213413f));
        tempValues2.add(new Coordinate<>(2013f, 414141f));
        tempValues2.add(new Coordinate<>(2014f, 432134f));
        tempValues2.add(new Coordinate<>(2015f, 387343f));
        tempValues2.add(new Coordinate<>(2016f, 392412f));
        tempValues2.add(new Coordinate<>(2017f, 333341f));
        tempValues2.add(new Coordinate<>(2018f, 350331f));
        tempValues2.add(new Coordinate<>(2019f, 390433f));

        List<Coordinate<Float, Float>> tempValues3 = new ArrayList<>();
        tempValues3.add(new Coordinate<>(2008f, 350000f));
        tempValues3.add(new Coordinate<>(2009f, 205000f));
        tempValues3.add(new Coordinate<>(2010f, 325000f));
        tempValues3.add(new Coordinate<>(2013f, 343000f));
        tempValues3.add(new Coordinate<>(2016f, 290000f));
        tempValues3.add(new Coordinate<>(2017f, 289000f));
        tempValues3.add(new Coordinate<>(2020f, 242000f));
        tempValues3.add(new Coordinate<>(2022f, 284000f));

        l1.setChartTitle("Number of People Eating Various Cakes");
        l1.setChartTitleColor(Color.parseColor("#333333"));
        l1.setXLabel("Year");
        l1.setXLabelColor(Color.parseColor("#333333"));
        l1.setXValueLabelsColor(Color.parseColor("#333333"));
        l1.setYLabel("People");
        l1.setYLabelColor(Color.parseColor("#555555"));
        l1.setYValueLabelsColor(Color.parseColor("#555555"));
        l1.setChartBackgroundColor(Color.parseColor("#999999"));
        l1.setGridlineWidth(2f);
        l1.setNumOfGridlines(3);
        l1.setChartGridlineColor(Color.parseColor("#777777"));
        l1.setZeroLineWidth(2f);
        l1.setZeroLineColor(Color.parseColor("#22BBFF"));
        l1.setUseNumberAbbreviationSuffixXValueChart(false);
        l1.setUseNumberAbbreviationSuffixYValueChart(true);
        l1.setDecimalFormatChartX(new DecimalFormat("#"));
        l1.setDecimalFormatChartY(new DecimalFormat("#"));
        l1.setDecimalFormatPopupX(new DecimalFormat("#"));
        l1.setDecimalFormatPopupY(new DecimalFormat("#,###.#"));
        l1.setRoundOutChartXMinMax(false);
        l1.setRoundOutChartYMinMax(true, 1);
        l1.addLine("Cheesecake", tempValues1, Color.RED);
        l1.addLine("Ice Cream Cake", tempValues2, Color.BLUE);
        l1.addLine("German Chocolate", tempValues3, Color.parseColor("#BBBB00"));
        l1.setUseAnimation(true);
        l1.setAnimationTime(2000f);
        l1.setBorderColor(Color.parseColor("#BBBBBB"));
        l1.setBorderWidth(6f);

        final LineChart l2 = (LineChart) v.findViewById(R.id.demo_main_linechart2);
        l2.setChartTitle("Number of People Eating Various Cakes");
        l2.setXLabel("Year");
        l2.setYLabel("People");
        l2.setRoundOutChartXMinMax(true, 3);
        l2.setRoundOutChartYMinMax(true, 2);
        l2.setUseNumberAbbreviationSuffixXValueChart(false);
        l2.setUseNumberAbbreviationSuffixYValueChart(true);
        l2.setUseNumberAbbreviationSuffixYValuePopup(true);
        l2.setNumberSuffixes("万億兆");
        l2.setNumberGroupSplit(4);
        l2.setDecimalFormatChartX(new DecimalFormat("#年"));
        l2.setDecimalFormatChartY(new DecimalFormat("#"));
        l2.setDecimalFormatPopupX(new DecimalFormat("#年"));
        l2.addLine("Cheesecake", tempValues1, Color.RED);
        l2.addLine("Ice Cream Cake", tempValues2, Color.BLUE);
        l2.addLine("German Chocolate", tempValues3, Color.parseColor("#BBBB00"));

        final BarChart b1 = (BarChart) v.findViewById(R.id.demo_main_barchart1);
        b1.setNumOfGridlines(3);
        b1.addBar("Bar1", -5450000f, Color.RED);
        b1.addBar("Bar2", -2550000f, Color.YELLOW);
        b1.addBar("Bar3", -1560000f, Color.BLUE);
        b1.addBar("Bar4", 3430000f, Color.GREEN);
        b1.addBar("Bar5", 1570000f, Color.MAGENTA);
        b1.setAllBarBorderColors(Color.parseColor("#FABDFA"));
        b1.setAllBarBorderWidths(6f);
        b1.setChartTitle("Bar Chart");
        b1.setZeroLineWidth(8f);
        b1.setZeroLineColor(Color.parseColor("#AA9922"));
        b1.setRoundOutChartYMinMax(true, 2);
        b1.setUseNumberAbbreviationSuffixYValueChart(true);
        b1.setUseNumberAbbreviationSuffixYValuePopup(true);
        b1.setDecimalFormatChartY(new DecimalFormat("#.#"));
        b1.setDecimalFormatPopupY(new DecimalFormat("#.##"));
        b1.setXLabel("Some Stuff");
        b1.setYLabel("Random Numbers");
        b1.setUseAnimation(true);
        b1.setAnimationTime(2000f);

        final BarChart b2 = (BarChart) v.findViewById(R.id.demo_main_barchart2);
        b2.setNumOfGridlines(4);
        b2.addBar("Canada", 1573f, Color.RED);
        b2.addBar("Japan", 4116f, Color.WHITE);
        b2.addBar("USA", 17968f, Color.BLUE);
        b2.addBar("Korea", 1393f, Color.BLACK);
        b2.addBar("China", 11385f, Color.MAGENTA);
        b2.addBar("Germany", 3371f, Color.YELLOW);
        b2.setDecimalFormatChartY(new DecimalFormat("#.#"));
        b2.setRoundOutChartYMinMax(true, 1);
        b2.setUseNumberAbbreviationSuffixYValueChart(true);
        b2.setDecimalFormatPopupY(new DecimalFormat("$#"));
        b2.setChartBackgroundColor(Color.parseColor("#AAAAAA"));
        b2.setChartTitle("GDP in 2015");
        b2.setXLabel("Nations");
        b2.setYLabel("US Dollars (Billions)");

        TextView tvPieChartTitle = (TextView) v.findViewById(R.id.demo_main_piechartstitle);
        tvPieChartTitle.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                p1.reanimate();
                p2.reanimate();
            }
        });

        TextView tvLineChartTitle = (TextView) v.findViewById(R.id.demo_main_linechartstitle);
        tvLineChartTitle.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                l1.reanimate();
                l2.reanimate();
            }
        });

        TextView tvBarChartTitle = (TextView) v.findViewById(R.id.demo_main_barchartstitle);
        tvBarChartTitle.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                b1.reanimate();
                b2.reanimate();
            }
        });

        return v;
    }
}
